/*
* Copyright (C) 2005, Pasi P. Liimatainen
* Distributable under GNU General Public License (v2)
* See terms of license at http://www.gnu.org
*/

//
// User.
//
function User(username, tagXmlSource) {
    this.username = username;
    this.mTags = new Tags(tagXmlSource);
}

User.prototype = {
	usersKey: 'delicious.users',
	passwordMgmtHost: 'delicious.mozdev.org',
	username: '',

    //
    // Get the account name for the user.
    //
    getAccountName: function()
    {
        return nsPreferences.copyUnicharPref(this.usersKey + '.' + this.username + ".accountname", "");
    },

    //
    // Set the account name for the user.
    //
    setAccountName: function(aAccountname)
    {
        nsPreferences.setUnicharPref(this.usersKey + '.' + this.username + ".accountname", aAccountname);
    },

    //
    // Get the password for the user.
    //
    getPassword: function()
    {
      var url = "chrome://delicious/";
      if ("@mozilla.org/passwordmanager;1" in Components.classes) {
        var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
        var enumerator = passwordManager.enumerator;
        while (enumerator.hasMoreElements()) {
            var pw = enumerator.getNext().QueryInterface(Components.interfaces.nsIPassword);
            if (pw.host == this.passwordMgmtHost && pw.user == this.username) {
                return pw.password;
            }
        }
      }
      else if ("@mozilla.org/login-manager;1" in Components.classes) {
        var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
        var logins = passwordManager.findLogins({}, url, null, this.passwordMgmtHost);
        if (logins.length > 0) {
          for (var i = 0; i < logins.length; i++) {
            login = logins[i];
            if (login.username == this.username) {
                return login.password === " " ? "" : login.password;
            }
          }
        }
      }
      return "";
    },

    //
    // Set the password for the user.
    //
    setPassword: function(aPassword)
    {
      var url = "chrome://delicious/";
      if ("@mozilla.org/passwordmanager;1" in Components.classes) {
        var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
        if (this.getPassword().length > 0) {
          passwordManager.removeUser(this.passwordMgmtHost, this.username);
        }
        passwordManager.addUser(this.passwordMgmtHost, this.username, aPassword);
      }
      else if ("@mozilla.org/login-manager;1" in Components.classes) {
        var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
        var logininfo = Components.classes["@mozilla.org/login-manager/loginInfo;1"].createInstance(Components.interfaces.nsILoginInfo);
        logininfo.init(url, null, this.passwordMgmtHost, this.username, aPassword, "", "");
        passwordManager.addLogin(logininfo);
      }
    },

    //
    // Get the del.icio.us username for the user.
    //
    getUsername: function()
    {
        return this.username;
    }
}

//
// Get tags for the user.
//
User.prototype.__defineGetter__("tags", function(){return this.mTags;});
